#jinja2: trim_blocks: True, lstrip_blocks: True
{{ ansible_managed | comment }}

{#  an opinionated website virtual host

    # the vhost name (primary domain name)
    item.name: string
    # the vhost domain list
    item.domain: string[] | d([])
    # the vhost root directory
    item.root: string | d(omit)
    # the vhost ssl capability
    item.ssl: boolean | d(item.certbot | d('no'))
    # redirect the non-ssl vhost to ssl counterpart
    item.redirect_ssl: boolean | d('yes')

    # the vhost network port
    item.port: int | d(nginx_network_port)
    # the vhost network ssl port
    item.ssl_port: int | d(nginx_network_ssl_port)

    # disable the vhost error log
    item.no_error_log: boolean | d('no')
    # the vhost access log format
    item.access_log_format: string | d(nginx_access_log_format)
    # disable the vhost access log
    item.no_access_log: boolean | d('no')

    # the vhost ssl certificate
    item.ssl_cert: string
    # the vhost ssl certificate key
    item.ssl_cert_key: string
    # the vhost ssl certificate chain
    item.ssl_cert_chain: string

    # the vhost snippet list
    item.snippet: dict[] | d([])
    # - name: string
    #   http: boolean | d('yes')
    #   ssl: boolean | d('yes')

    # the vhost custom block
    item.custom: string | d(omit)
    # the vhost custom ssl block
    item.ssl_custom: string | d(item.custom)
-#}

server {
    listen {{ item.port | d(nginx_network_port) }}{% if item.backlog is defined %} backlog={{ item.backlog }}{% endif %}{% if item.default | d('no') | bool %} default_server{% endif %};
    listen [::]:{{ item.port | d(nginx_network_port) }}{% if item.backlog is defined %} backlog={{ item.backlog }}{% endif %}{% if item.default | d('no') | bool %} default_server{% endif %};
    server_name {% if item.domain is defined %}{{ item.domain | join(' ') }}{% else %}{{ item.name | mandatory }}{% endif %};
    {% if item.root is defined %}
    root {{ item.root | mandatory }};
    {% endif %}

    {% if not item.no_error_log | d('no') | bool %}
    error_log {{ nginx_logdir }}/{{ item.name | mandatory }}.error_log warn;
    {% endif %}
    {% if not item.no_access_log | d('no') | bool %}
    access_log {{ nginx_logdir }}/{{ item.name | mandatory }}.access_log {{ item.access_log_format | d(nginx_access_log_format) }};
    {% endif %}

    {% if item.snippetable | d('no') | bool %}
    include {{ nginx_confdir }}/{{ item.name | mandatory }}.d/*.conf;
    {% endif %}
    include {{ nginx_confdir }}/snippet.d/favicon.ico.conf;
    include {{ nginx_confdir }}/snippet.d/robots.txt.conf;
    {% if item.certbot | d('no') | bool %}
    include {{ nginx_confdir }}/snippet.d/certbot-acme.conf;
    {% endif %}
    {% if item.ssl | d(item.certbot | d('no')) | bool and item.redirect_ssl | d('yes') | bool %}
    include {{ nginx_confdir }}/snippet.d/redirect-ssl.conf;
    {% endif %}
    {% for _nginx_snippet in item.snippet | d([]) %}
    {% if _nginx_snippet.http | d('yes') | bool %}
    include {{ _nginx_snippet.name | mandatory }};
    {% endif %}
    {% endfor %}
    {% if item.custom is defined %}

    {{ item.custom | indent(4, False) }}
    {% endif %}
}
{% if item.ssl | d(item.certbot | d('no')) | bool %}

server {
    listen {{ item.ssl_port | d(nginx_network_ssl_port) }} ssl http2{% if item.backlog is defined %} backlog={{ item.backlog }}{% endif %}{% if item.default | d('no') | bool %} default_server{% endif %};
    listen [::]:{{ item.ssl_port | d(nginx_network_ssl_port) }} ssl http2{% if item.backlog is defined %} backlog={{ item.backlog }}{% endif %}{% if item.default | d('no') | bool %} default_server{% endif %};
    server_name {% if item.domain is defined %}{{ item.domain | join(' ') }}{% else %}{{ item.name | mandatory }}{% endif %};
    {% if item.root is defined %}
    root {{ item.root | mandatory }};
    {% endif %}

    {% if not item.no_error_log | d('no') | bool %}
    error_log {{ nginx_logdir }}/{{ item.name | mandatory }}.error_log warn;
    {% endif %}
    {% if not item.no_access_log | d('no') | bool %}
    access_log {{ nginx_logdir }}/{{ item.name | mandatory }}.access_log {{ item.access_log_format | d(nginx_access_log_format) }};
    {% endif %}

    ssl_certificate {{ item.ssl_cert | d('/etc/letsencrypt/live/' ~ (item.name | mandatory) ~ '/fullchain.pem') }};
    ssl_certificate_key {{ item.ssl_cert_key | d('/etc/letsencrypt/live/' ~ (item.name | mandatory) ~ '/privkey.pem') }};
    ssl_trusted_certificate {{ item.ssl_cert_chain | d('/etc/letsencrypt/live/' ~ (item.name | mandatory) ~ '/fullchain.pem') }};

    {% if item.snippetable | d('no') | bool %}
    include {{ nginx_confdir }}/{{ item.name | mandatory }}.d/*.conf;
    {% endif %}
    include {{ nginx_confdir }}/snippet.d/favicon.ico.conf;
    include {{ nginx_confdir }}/snippet.d/robots.txt.conf;
    include {{ nginx_confdir }}/snippet.d/mozilla-ssl-config.conf;
    {% for _nginx_snippet in item.snippet | d([]) %}
    {% if _nginx_snippet.ssl | d('yes') | bool %}
    include {{ _nginx_snippet.name | mandatory }};
    {% endif %}
    {% endfor %}
    {% if item.ssl_custom is defined or item.custom is defined %}

    {{ item.ssl_custom | d(item.custom) | indent(4, False) }}
    {% endif %}
}
{% endif %}
